//	uart_i.c - initialize UART
//	Mike Dawdy, Compuserve ID 76275,700

#include  "uart.h"

void uart_init(
     unsigned addr, unsigned baud, unsigned lcr, unsigned mcr, unsigned ier)
{
unsigned scr, divisor, ticks;

outp(addr+IER, 0x00); 	// disable pending port interrupts
outp(addr+SCR, 0x12); 	// determine if INS8250-B chip

if ((scr = inp(addr+SCR)) != 0x12) outp(addr+MCR, MCR_LOOP);
outp(addr+LCR, 0x80); 	// initialize baud rate
if (baud == 0)		// 0 represents 115200
   divisor = 1;
else
   divisor = (unsigned)(115200L / baud);
outp(addr+DLM, (divisor >> 8));
outp(addr+DLL, divisor);

outp(addr+LCR, lcr);	// set line control register
if (scr != 0x12)
{			// NatSem says wait 1 char time
   ticks = *(unsigned far *)TICKS + 2;
   while (*(volatile unsigned far *)TICKS != ticks) ;
}

inp(addr+TRB);		// reset rec data available
inp(addr+LSR);		// reset OR, PA, FR & BR
inp(addr+MSR);		// reset cts, dsr, ri & dcd
inp(addr+IIR);		// reset possible pending THRE interrupt

outp(addr+MCR, mcr);	// set modem control register
outp(addr+IER, ier);	// set interrupt enable register
}

